package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDDiagram_isComposedBy_SDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDState_hasActivity_SDActivity;


/**
 * @author Andrea Frasca
 */
public class SDActivity_Factory {
	
	public SDActivity activity;
	
	public SDActivity createInstance(SDDiagram diagram, SDState state){
		this.activity = new SDActivity();
		this.resolveLinkConstraints(diagram, state);
		return this.activity;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram, SDState state) {
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.activity);
		SDState_hasActivity_SDActivity.addLink(
				state, this.activity);
		
	}
	
}
