package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDDiagram_isComposedBy_SDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasEvent_SDEvent;

/**
 * @author Andrea Frasca
 */
public class SDEvent_Factory {
	
	public SDEvent event;
	
	public SDEvent createInstance(SDDiagram diagram, SDTransition transition){
		this.event = new SDEvent();
		this.resolveLinkConstraints(diagram, transition);
		return this.event;
	}
	
	public SDEvent createInstance(SDDiagram diagram, SDTransition transition, String name){
		this.event = new SDEvent(name);
		this.resolveLinkConstraints(diagram, transition);
		return this.event;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram, SDTransition transition) {
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.event);
		SDTransition_hasEvent_SDEvent.addLink(
				transition, this.event);
	}
		
}
