package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDDiagram_isComposedBy_SDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDMacroState_containsInitState_SDState;

/**
 * @author Andrea Frasca
 */
public class SDMacroState_Factory {
	
	public SDMacroState macrostate;
	
	public SDMacroState createInstance(SDDiagram diagram, SDState initstate ,String name) {
		this.macrostate = new SDMacroState(name);
		this.resolveLinkConstraints(diagram,initstate);
		return this.macrostate;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram, SDState initstate) {
		
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.macrostate);
		SDMacroState_containsInitState_SDState.addLink(
				this.macrostate, initstate);
	}
	
}
