package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDDiagram_isComposedBy_SDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasDestination_SDState;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasOrigin_SDState;

/**
 * @author Andrea Frasca
 */
public class SDTransition_Factory {
	
	public SDTransition transition;
	
	/*
	public SDTransition createInstance(SDDiagram diagram, SDEvent event,
			SDState originState, SDState destState) {
		this.transition = new SDTransition();
		this.resolveLinkConstraints(diagram, event, originState, destState);
		return this.transition;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram, SDEvent event,
			SDState originState, SDState destState) {
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.transition);
		SDTransition_hasEvent_SDEvent.addLink(
				this.transition, event);
		SDTransition_hasDestination_SDState.addLink(
				this.transition, destState);
		SDTransition_hasOrigin_SDState.addLink(
				this.transition, originState);		
	}*/
	
	public SDTransition createInstance(SDDiagram diagram,
			SDState originState, SDState destState, String name) {
		this.transition = new SDTransition(name);
		this.resolveLinkConstraints(diagram, originState, destState);
		return this.transition;
	}
	
	public SDTransition createInstance(SDDiagram diagram,
			SDState originState, SDState destState) {
		this.transition = new SDTransition();
		this.resolveLinkConstraints(diagram, originState, destState);
		return this.transition;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram,
			SDState originState, SDState destState) {
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.transition);
		SDTransition_hasDestination_SDState.addLink(
				this.transition, destState);
		SDTransition_hasOrigin_SDState.addLink(
				this.transition, originState);		
	}
	
}
