package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDDiagram;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDElement;

/**
 * @author Andrea Frasca
 */
public class SDDiagram_isComposedBy_SDElement {
	
	private SDDiagram diagram;
	private SDElement element;

	private SDDiagram_isComposedBy_SDElement(
			SDDiagram diagram, SDElement element) {
		this.diagram = diagram;
		this.element = element;
	}

	public static void addLink(
			SDDiagram diagram, SDElement element) {
		SDDiagram_isComposedBy_SDElement self =
			new SDDiagram_isComposedBy_SDElement(
					diagram, element);
		diagram.addElement(self);
		element.setDiagram(self);
	}

	public static void removeLink(
			SDDiagram diagram, SDElement element) {
		SDDiagram_isComposedBy_SDElement self =
			new SDDiagram_isComposedBy_SDElement(
					diagram, element);
		diagram.removeElement(self);
		element.unsetDiagram(self);
	}

	public SDDiagram getDiagram() {
		return this.diagram;
	}

	public SDElement getElement() {
		return this.element;
	}
}
