package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDAction;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDTransition;

/**
 * @author Andrea Frasca
 */
public class SDTransition_hasAction_SDAction {
	
	private SDTransition transition;
	private SDAction action;
	
	private SDTransition_hasAction_SDAction(SDTransition transition, SDAction action){
		this.transition = transition;
		this.action = action;
	}
	
	public static void addLink(
			SDTransition transition, SDAction action) {
		SDTransition_hasAction_SDAction self =
			new SDTransition_hasAction_SDAction(
					transition, action);
		transition.setAction(self);
		action.addTransition(self);
	}

	public static void removeLink(
			SDTransition transition, SDAction action) {
		SDTransition_hasAction_SDAction self =
			new SDTransition_hasAction_SDAction(
					transition, action);
		transition.unsetAction(self);
		action.removeTransition(self);
	}
	
	public SDTransition getTransition(){
		return this.transition;
	}
	
	public SDAction getAction(){
		return this.action;
	}
}
