package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDEvent;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDTransition;

/**
 * @author Andrea Frasca
 */
public class SDTransition_hasEvent_SDEvent {
	
	private SDTransition transition;
	private SDEvent event;
	
	private SDTransition_hasEvent_SDEvent(SDTransition transition, SDEvent event){
		this.transition = transition;
		this.event = event;
	}
	
	public static void addLink(
			SDTransition transition, SDEvent event) {
		SDTransition_hasEvent_SDEvent self =
			new SDTransition_hasEvent_SDEvent(
					transition, event);
		transition.setEvent(self);
		event.addTransition(self);
	}

	public static void removeLink(
			SDTransition transition, SDEvent event) {
		SDTransition_hasEvent_SDEvent self =
			new SDTransition_hasEvent_SDEvent(
					transition, event);
		transition.unsetEvent(self);
		event.removeTransition(self);
	}
	
	public SDTransition getTransition(){
		return this.transition;
	}
	
	public SDEvent getEvent(){
		return this.event;
	}

}
