/*
 * EdgeST.java
 *
 * Created on 3 dicembre 2008, 15.45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */


package it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Line2D;

/**
 *
 * @author Gianluca pc
 */
public class EdgeST extends Edge{
   
   private Line2D linea;
   private Point startPoint;
   private Point endPoint;
   private StateFrame tail;
   private StateFrame head;
   private String ev;
   private boolean selected = false;
    /** Creates a new instance of EdgeST */
    public EdgeST(Figure tail,Figure head,Line2D line,String evento) {
        
        super(tail,head);
        //System.out.println("Event : " + evento);
        this.tail = (StateFrame)tail;
        this.head = (StateFrame)head;
        linea = line;
        setLabelName(evento);
        if(line != null){
        startPoint = tail.getLineIntersection(linea);
        endPoint = head.getLineIntersection(linea);
        }
     //   ev = evento;
     //   setLabelName(ev);
    }
    
    public boolean getSelected(){
    	return selected;
    }
    
    public void setSelected(boolean b){
    	selected = b;
    }
    
    public void draw(Graphics2D g){
    	if(selected) g.setColor(Color.RED);
    	else g.setColor(Color.BLACK);
        g.drawLine(startPoint.x,startPoint.y,endPoint.x,endPoint.y);
        drawCuspide(g,startPoint,endPoint);
        labelName.setPosition(new Point((startPoint.x + endPoint.x)/2,(startPoint.y + endPoint.y)/2));
        labelName.draw(g);
    }
    
//    public void setPoint(){
//        Point start = tail.getCG();
//        Point end = head.getCG();
//        Line2D line = new Line2D.Double(start.x,start.y,end.x,end.y);
//        startPoint = tail.getLineIntersection(line);
//        endPoint = head.getLineIntersection(line);
//    }
    public boolean cover(EdgeST e){
        return ((getStartPoint().equals(e.getStartPoint()) && getEndPoint().equals(e.getEndPoint())) ||
                (getStartPoint().equals(e.getEndPoint()) && getEndPoint().equals(e.getStartPoint())));
    }
    
    public void setStartPoint(Point p) {
        startPoint = p;
    }
    
    public void setEndPoint(Point p) {
        endPoint = p;
    }
    
    public Point getStartPoint() {
        return startPoint;
    }
    
    public Point getEndPoint() {
        return endPoint;
    }
    
    public StateFrame getTail(){
        return tail;
    }
    
    public StateFrame getHead(){
        return head;
    }
    
    public String getName(){
        return labelName.getText();
    }
}
