package it.uniroma1.dis.mfis.redia.verifint.control;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDDiagram;

/**
 * @author Andrea Frasca
 */
public class ConceptualStateTransitionDiagramManager {
	
	private SDDiagram diagram;
	
	public ConceptualStateTransitionDiagramManager(Archive archive) {
		super();
		this.diagram = archive.getConceptualStateTransitionDiagram();
	}

	public ConceptualStateTransitionDiagramManager() {
		super();
	}

	public SDDiagram getDiagram() {
		return diagram;
	}

	void setDiagram(SDDiagram diagram) {
		this.diagram = diagram;
	}

}
