package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDDiagram_isComposedBy_SDElement;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDTransition_hasAction_SDAction;

/**
 * @author Andrea Frasca
 */
public class SDAction_Factory {
	
	public SDAction action;
	
	public SDAction createInstance(SDDiagram diagram, SDTransition transition){
		this.action = new SDAction();
		this.resolveLinkConstraints(diagram, transition);
		return this.action;
	}
	
	public SDAction createInstance(SDDiagram diagram, SDTransition transition, String name){
		this.action = new SDAction(name);
		this.resolveLinkConstraints(diagram, transition);
		return this.action;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram, SDTransition transition) {
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.action);
		SDTransition_hasAction_SDAction.addLink(
				transition, this.action);
	}
		
}
