package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link.SDDiagram_isComposedBy_SDElement;

/**
 * @author Andrea Frasca
 */
public class SDState_Factory {
	
	public SDState state;
	
	public SDState createInstance(SDDiagram diagram) {
		this.state = new SDState();
		this.resolveLinkConstraints(diagram);
		return this.state;
	}
	
	public SDState createInstance(SDDiagram diagram, String name) {
		this.state = new SDState(name);
		this.resolveLinkConstraints(diagram);
		return this.state;
	}
	
	private void resolveLinkConstraints(SDDiagram diagram) {
		SDDiagram_isComposedBy_SDElement.addLink(
				diagram, this.state);
	}
	
}
