package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDActivity;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDState;

/**
 * @author Andrea Frasca
 */
public class SDState_hasActivity_SDActivity {
	
	private SDState state;
	private SDActivity activity;
	
	private SDState_hasActivity_SDActivity(
			SDState state, SDActivity activity) {
		this.state = state;
		this.activity = activity;
	}

	public static void addLink(
			SDState state, SDActivity activity) {
		SDState_hasActivity_SDActivity self =
			new SDState_hasActivity_SDActivity(
					state, activity);
		state.addActivity(self);
		activity.addState(self);
	}

	public static void removeLink(
			SDState state, SDActivity activity) {
		SDState_hasActivity_SDActivity self =
			new SDState_hasActivity_SDActivity(
					state, activity);
		state.removeActivity(self);
		activity.removeState(self);
	}
	
	public SDState getState(){
		return this.state;
	}
	
	public SDActivity getActivity(){
		return this.activity;
	}
	
}
