package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDCondition;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDTransition;

/**
 * @author Andrea Frasca
 */
public class SDTransition_hasCondition_SDCondition {
	
	private SDTransition transition;
	private SDCondition condition;
	
	private SDTransition_hasCondition_SDCondition(SDTransition transition, SDCondition condition){
		this.transition = transition;
		this.condition = condition;
	}
	
	public static void addLink(
			SDTransition transition, SDCondition condition) {
		SDTransition_hasCondition_SDCondition self =
			new SDTransition_hasCondition_SDCondition(
					transition, condition);
		transition.setCondition(self);
		condition.addTransition(self);
	}

	public static void removeLink(
			SDTransition transition, SDCondition condition) {
		SDTransition_hasCondition_SDCondition self =
			new SDTransition_hasCondition_SDCondition(
					transition, condition);
		transition.unsetCondition(self);
		condition.removeTransition(self);
	}
	
	public SDTransition getTransition(){
		return this.transition;
	}
	
	public SDCondition getCondition(){
		return this.condition;
	}
	
}
