package it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams._link;

import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDState;
import it.uniroma1.dis.mfis.redia.verifint.model.analysis.stateDiagrams.SDTransition;

/**
 * @author Andrea Frasca
 */
public class SDTransition_hasDestination_SDState {
	
	private SDTransition transition;
	private SDState state;
	
	private SDTransition_hasDestination_SDState(SDTransition transition, SDState state){
		this.transition = transition;
		this.state = state;
	}
	
	public static void addLink(
			SDTransition transition, SDState state) {
		SDTransition_hasDestination_SDState self =
			new SDTransition_hasDestination_SDState(
					transition, state);
		transition.setDestination(self);
		state.addIsDestination(self);
	}

	public static void removeLink(
			SDTransition transition, SDState state) {
		SDTransition_hasDestination_SDState self =
			new SDTransition_hasDestination_SDState(
					transition, state);
		transition.unsetDestination(self);
		state.removeIsDestination(self);
	}
	
	public SDTransition getTransition(){
		return this.transition;
	}
	
	public SDState getState(){
		return this.state;
	}
	
}
