/*
 * EdgeLoop.java
 *
 * Created on 5 dicembre 2008, 14.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package it.uniroma1.dis.mfis.redia.verifint.view.graphics.engine;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.geom.Rectangle2D;

/**
 *
 * @author Gianluca pc
 */
public class EdgeLoop extends EdgeST{
    
    /** Creates a new instance of EdgeLoop */
    public EdgeLoop(Figure tail,String label) {
        super(tail,tail,null,label);
        if(tail instanceof StateFrame){
            StateFrame t = (StateFrame)tail;
            Point p = t.getPosition();
            Dimension d = t.getDimension();
            super.setStartPoint(new Point(p.x+30,p.y));
            super.setEndPoint(new Point(p.x+35,p.y));
        }
        if(tail instanceof DecisionFrame){
            DecisionFrame df = (DecisionFrame)tail;
            Polygon p = df.getPolygon();
            
        }
    }
    
    public boolean isNear(Point p){
    	boolean near = false;
    	Rectangle2D r = new Rectangle2D.Double(getStartPoint().x-15,getStartPoint().y-25,40,25);
    	near = r.contains(p);
    	return near;
    }
    
    public void setPoint(){
        Figure t = super.getTail();
        Point p = t.getPosition();
        Dimension d = t.getDimension();
        super.setStartPoint(new Point(p.x+30,p.y));
        super.setEndPoint(new Point(p.x+35,p.y));
    }
    
    public void draw(Graphics2D g){
    	if(getSelected()) g.setColor(Color.RED);
    	else g.setColor(Color.BLACK);
        Point ps = super.getStartPoint();
        Point pe = super.getEndPoint();
        g.drawLine(ps.x,ps.y,ps.x-15,ps.y-25);
        g.drawLine(ps.x-15,ps.y-25,ps.x+25,ps.y-25);
        g.drawLine(ps.x+25,ps.y-25,pe.x,pe.y);
        drawCuspide(g,new Point(ps.x+25,ps.y-25),pe);
        labelName.setPosition(new Point((ps.x + pe.x)/2 - 10,(ps.y + pe.y)/2 - 26));
        labelName.draw(g);
    }
    
}
